<?php
/* Autor...:  */
/* Esquema.: SEG_SucursalUsuario.xml */
/* Generado: 2020-08-18 04:21:30 */

/* Metodos de acceso a los campos de la tabla SEG_SucursalUsuario */
abstract class BaseSEG_SucursalUsuarioBN
{
    /* Campos de la tabla */
    private $s_IdUsuario;    // IdUsuario: ( no definido )
    private $i_IdSucursal;    // IdSucursal: ( no definido )
    private $i_IdCompania;    // IdCompania: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )

    /* Establece el valor del campo IdUsuario */
    public function setIdUsuario( $s_IdUsuario )
    {
        $this->s_IdUsuario = $s_IdUsuario;
    }

    /* Obtiene el valor del campo IdUsuario */
    public function getIdUsuario()
    {
        return $this->s_IdUsuario;
    }

    /* Establece el valor del campo IdSucursal */
    public function setIdSucursal( $i_IdSucursal )
    {
        $this->i_IdSucursal = $i_IdSucursal;
    }

    /* Obtiene el valor del campo IdSucursal */
    public function getIdSucursal()
    {
        return $this->i_IdSucursal;
    }

    /* Establece el valor del campo IdCompania */
    public function setIdCompania( $i_IdCompania )
    {
        $this->i_IdCompania = $i_IdCompania;
    }

    /* Obtiene el valor del campo IdCompania */
    public function getIdCompania()
    {
        return $this->i_IdCompania;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdUsuario' => $this->getIdUsuario(),
            'IdSucursal' => $this->getIdSucursal(),
            'IdCompania' => $this->getIdCompania(),
            'Estado' => $this->getEstado(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto SEG_SucursalUsuarioBN desde un RecordSet */
    public static function retrieveByRs( $o_SEG_SucursalUsuarioRs )
    {
        $o_SEG_SucursalUsuarioBN = new SEG_SucursalUsuarioBN();
        $o_SEG_SucursalUsuarioBN->setIdUsuario( $o_SEG_SucursalUsuarioRs[ "IdUsuario" ] );
        $o_SEG_SucursalUsuarioBN->setIdSucursal( ( integer ) $o_SEG_SucursalUsuarioRs[ "IdSucursal" ] );
        $o_SEG_SucursalUsuarioBN->setIdCompania( ( integer ) $o_SEG_SucursalUsuarioRs[ "IdCompania" ] );
        $o_SEG_SucursalUsuarioBN->setEstado( $o_SEG_SucursalUsuarioRs[ "Estado" ] );
        $o_SEG_SucursalUsuarioBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_SEG_SucursalUsuarioRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_SEG_SucursalUsuarioBN->setUsuarioCreacion( $o_SEG_SucursalUsuarioRs[ "UsuarioCreacion" ] );
        $o_SEG_SucursalUsuarioBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_SEG_SucursalUsuarioRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_SEG_SucursalUsuarioBN->setUsuarioModificacion( $o_SEG_SucursalUsuarioRs[ "UsuarioModificacion" ] );
        return $o_SEG_SucursalUsuarioBN;
    }
}
?>